#include "gdew0213m21_epd.h"

uint8_t gdew0213m21_init_sequence[] = {
    0x03, 0x06, 0x17, 0x17, 0x1F, // boost soft start
    0x04, 0x01, 0x03, 0x00, 0x2B, 0x2B, // Power settings
    0x01, 0x00, 0xBF, // Panel setting, LUT from OTP
    0x01, 0x30, 0x3C,
    0x03, 0x61, 0x68, 0x00, 0xD4,
    0x01, 0x82, 0x12, // VCOM DC settings
    0x01, 0x50, 0x47
};

des_epd_ret_t _des_epd_hardware_reset(des_epd_t *epd) {
    //
}

des_epd_ret_t _des_epd_software_reset(des_epd_t *epd) {
    //
}

des_epd_ret_t _des_epd_init_seq(des_epd_t *epd) {
   uint16_t i = 0;
    while(i < sizeof(DES_EPD_PANEL_SELECTION)) {
        DES_EPD_ERROR_CHECK(epd->cb.write_cmd_cb(epd->user_data, &DES_EPD_PANEL_SELECTION[i + 1], DES_EPD_PANEL_SELECTION[i] + 1));
        i += DES_EPD_PANEL_SELECTION[i] + 2;
    }

    return DES_EPD_OK;
}

des_epd_ret_t des_epd_init(des_epd_t *epd) {
    DES_EPD_ERROR_CHECK(_des_epd_init_seq(epd));

    return DES_EPD_OK;
}